#include "xwatch.h"

/* lazy function to duplicate a string
 *
 */
#if !HAVE_STRDUP
char *
strdup(str)
  char *str;
{
	int len;
	char *newstr;

	len = strlen(str) + 1;
	if (!(newstr = malloc(len))) return NULL;
	memcpy(newstr, str, len);
	
	return newstr;
}
#endif

int
xread(fd, buf, size)
  int fd;
  void *buf;
  size_t size;
{
	int c;
	size_t left;

	left = size;
	while (left > 0) {
		c = read(fd, buf, left);
		if (c == -1 || c == 0) return FALSE;
		left -= c;
		buf = (void *) (((char *) buf)+c);
	}
	return TRUE;
}

#ifdef STDC_HEADERS
void
printerror(char *firststr, ...)
#else
void
printerror(va_alist)
  va_dcl
#endif
{
	char *str;
	va_list ap;

	write(STDOUT_FILENO, "xwatch: ", 8);

#ifdef STDC_HEADERS
	write(STDOUT_FILENO, firststr, strlen(firststr));
	va_start(ap, firststr);
#else
	va_start(ap);
#endif

	while ((str = va_arg(ap, char *)))
		write(STDOUT_FILENO, str, strlen(str));

	write(STDOUT_FILENO, "\n", 1);

	va_end(ap);
}

void
syslog_time_to_tm (str, tm)
  char *str;
  struct tm *tm;
{
	register char ch1,ch2,ch3;

	tm->tm_hour = (str[7]-'0')*10+(str[8]-'0');
	tm->tm_min = (str[10]-'0')*10+(str[11]-'0');
	tm->tm_sec = (str[13]-'0')*10+(str[14]-'0');
	tm->tm_mday = (str[4]-'0')*10+(str[5]-'0');
	tm->tm_year = 0;
	tm->tm_wday = 0;
	tm->tm_yday = 0;
	tm->tm_isdst = 0;

	/* extremely optimized month testing scheme follows :) */

	ch1 = str[0]; ch2 = str[1]; ch3 = str[2];
											// get: Jan,Feb,Mar,Apr,May,Jun,Jul,Aug,Sep,Oct,Nov,Dec
	if (ch1 == 'J')							//   get: Jan,Jun,Jul
		if (ch2 == 'u')						//     get: Jun,Jul
			if (ch3 == 'n') tm->tm_mon = 5;	//       get: Jun
			else tm->tm_mon = 6;			//       rem: Jul
		else tm->tm_mon = 0;				//     rem: Jan
	else if (ch2 == 'e')					//   get: Feb,Sep,Dec
		if (ch1 == 'F') tm->tm_mon = 1;		//     get: Feb
		else if (ch1 == 'S') tm->tm_mon = 8;//     get: Sep
		else tm->tm_mon = 11;				//     rem: Dec
	else if (ch1 == 'M')					//   get: Mar,May
		if (ch3 == 'r') tm->tm_mon = 2;		//     get: Mar
		else tm->tm_mon = 4;				//     rem: May
	else if (ch1 == 'A')					//   get: Apr,Aug
		if (ch2 == 'p') tm->tm_mon = 3;		//     get: Apr
		else tm->tm_mon = 7;				//     rem: Aug
	else if (ch1 == 'O') tm->tm_mon = 9;	//   get: Oct
	else tm->tm_mon = 10;					//   rem: Nov

	/* total character tests for
	 * Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec
	 *   2   3   4   5   4   3   3   5   4   5   5   4
     * best case: 2   worst case: 5   average case:  3.9
	 */
}
